package com.sun.corba.se.impl.protocol;

import com.sun.corba.se.spi.oa.ObjectAdapter;
import com.sun.corba.se.spi.protocol.CorbaMessageMediator;

public abstract class SpecialMethod
{
    static SpecialMethod[] methods;
    
    public SpecialMethod() {
    }
    
    public abstract boolean isNonExistentMethod();
    
    public abstract String getName();
    
    public abstract CorbaMessageMediator invoke(Object p0, CorbaMessageMediator p1, byte[] p2, ObjectAdapter p3);
    
    public static final SpecialMethod getSpecialMethod(String anObject) {
        int i = 0;
        while (i < SpecialMethod.methods.length) {
            if (SpecialMethod.methods[i].getName().equals(anObject)) {
                return SpecialMethod.methods[i];
            }
            ++i;
        }
        return null;
    }
    
    static {
        SpecialMethod.methods = new SpecialMethod[] { new IsA(), new GetInterface(), new NonExistent(), new NotExistent() };
    }
}
